fix a problem with two different applet_name's
[oweals/busybox.git] / scripts / trylink
1 #!/bin/sh
2
3 debug=false
4
5 # Linker flags used:
6 #
7 # Informational:
8 # --warn-common
9 # -Map $EXE.map
10 # --verbose
11 #
12 # Optimizations:
13 # --sort-common                 reduces padding
14 # --sort-section alignment      reduces padding
15 # --gc-sections                 throws out unused sections,
16 #                               does not work for shared libs
17 # -On                           Not used, maybe useful?
18 #
19 # List of files to link:
20 # $l_list                       == --start-group -llib1 -llib2 --end-group
21 # --start-group $O_FILES $A_FILES --end-group
22 #
23 # Shared library link:
24 # -shared                       self-explanatory
25 # -fPIC                         position-independent code
26 # --enable-new-dtags            ?
27 # -z,combreloc                  ?
28 # -soname="libbusybox.so.$BB_VER"
29 # --undefined=lbb_main          Seed name to start pulling from
30 #                               (otherwise we'll need --whole-archive)
31 # -static                       Not used, but may be useful! manpage:
32 #                               "... This option can be used with -shared.
33 #                               Doing so means that a shared library
34 #                               is being created but that all of the library's
35 #                               external references must be resolved by pulling
36 #                               in entries from static libraries."
37
38
39 try() {
40     printf "%s\n" "Output of:" >$EXE.out
41     printf "%s\n" "$*" >>$EXE.out
42     printf "%s\n" "==========" >>$EXE.out
43     $debug && echo "Trying: $*"
44     "$@" >>$EXE.out 2>&1
45     exitcode=$?
46     return $exitcode
47 }
48
49 EXE="$1"
50 CC="$2"
51 LDFLAGS="$3"
52 O_FILES="$4"
53 A_FILES="$5"
54 LDLIBS="$6"
55
56 # Sanitize lib list (dups, extra spaces etc)
57 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
58
59 # First link with all libs. If it fails, bail out
60 echo "Trying libraries: $LDLIBS"
61 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
62 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
63 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
64 try $CC $LDFLAGS \
65         -o $EXE \
66         -Wl,--sort-common \
67         -Wl,--sort-section -Wl,alignment \
68         -Wl,--gc-sections \
69         -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
70         $l_list \
71 || {
72     echo "Failed: $* $l_list"
73     cat $EXE.out
74     exit 1
75 }
76
77 # Now try to remove each lib and build without it.
78 # Stop when no lib can be removed.
79 while test "$LDLIBS"; do
80     $debug && echo "Trying libraries: $LDLIBS"
81     all_needed=true
82     for one in $LDLIBS; do
83         without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
84         # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
85         l_list=`echo "$without_one" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
86         test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
87         $debug && echo "Trying -l options: '$l_list'"
88         try $CC $LDFLAGS \
89                 -o $EXE \
90                 -Wl,--sort-common \
91                 -Wl,--sort-section -Wl,alignment \
92                 -Wl,--gc-sections \
93                 -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
94                 $l_list
95         if test $? = 0; then
96             echo "Library $one is not needed"
97             LDLIBS="$without_one"
98             all_needed=false
99         else
100             echo "Library $one is needed"
101         fi
102     done
103     # All libs were needed, can't remove any
104     $all_needed && break
105     # If there is no space char, the list has just one lib.
106     # I'm not sure that in this case lib really is 100% needed.
107     # Let's try linking without it anyway... thus commented out.
108     #{ echo "$LDLIBS" | grep -q ' '; } || break
109 done
110
111 # Make the binary with final, minimal list of libs
112 echo "Final link with: $LDLIBS"
113 l_list=`echo "$LDLIBS" | sed -e 's/ / -l/g' -e 's/^/-l/' -e 's/^-l$//'`
114 test "x$l_list" != "x" && l_list="-Wl,--start-group $l_list -Wl,--end-group"
115 # --verbose gives us gobs of info to stdout (e.g. linker script used)
116 if ! test -f busybox_ldscript; then
117     try $CC $LDFLAGS \
118             -o $EXE \
119             -Wl,--sort-common \
120             -Wl,--sort-section -Wl,alignment \
121             -Wl,--gc-sections \
122             -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
123             $l_list \
124             -Wl,--warn-common \
125             -Wl,-Map -Wl,$EXE.map \
126             -Wl,--verbose \
127     || {
128         cat $EXE.out
129         exit 1
130     }
131 else
132     echo "Custom linker script 'busybox_ldscript' found, using it"
133     # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
134     #  .rodata         : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
135     #  *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
136     #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
137     # This will eliminate most of the padding (~3kb).
138     # Hmm, "ld --sort-section alignment" should do it too.
139     try $CC $LDFLAGS \
140             -o $EXE \
141             -Wl,--sort-common \
142             -Wl,--sort-section -Wl,alignment \
143             -Wl,--gc-sections \
144             -Wl,-T -Wl,busybox_ldscript \
145             -Wl,--start-group $O_FILES $A_FILES -Wl,--end-group \
146             $l_list \
147             -Wl,--warn-common \
148             -Wl,-Map -Wl,$EXE.map \
149             -Wl,--verbose \
150     || {
151         cat $EXE.out
152         exit 1
153     }
154 fi
155
156 . ./.config
157
158 sharedlib_dir="0_lib"
159
160 if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
161     mkdir "$sharedlib_dir" 2>/dev/null
162     test -d "$sharedlib_dir" || {
163         echo "Cannot make directory $sharedlib_dir"
164         exit 1
165     }
166     ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
167
168     EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
169     try $CC $LDFLAGS \
170             -o $EXE \
171             -shared -fPIC \
172             -Wl,--enable-new-dtags \
173             -Wl,-z,combreloc \
174             -Wl,-soname="libbusybox.so.$BB_VER" \
175             -Wl,--undefined=lbb_main \
176             -Wl,--sort-common \
177             -Wl,--sort-section -Wl,alignment \
178             -Wl,--start-group $A_FILES -Wl,--end-group \
179             $l_list \
180             -Wl,--warn-common \
181             -Wl,-Map -Wl,$EXE.map \
182             -Wl,--verbose \
183     || {
184         echo "Linking $EXE failed"
185         cat $EXE.out
186         exit 1
187     }
188     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
189     chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
190     echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
191 fi
192
193 if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
194     EXE="$sharedlib_dir/busybox_unstripped"
195     try $CC $LDFLAGS \
196             -o $EXE \
197             -Wl,--sort-common \
198             -Wl,--sort-section -Wl,alignment \
199             -Wl,--gc-sections \
200             -Wl,--start-group $O_FILES -Wl,--end-group \
201             -L"$sharedlib_dir" -lbusybox \
202             -Wl,--warn-common \
203             -Wl,-Map -Wl,$EXE.map \
204             -Wl,--verbose \
205     || {
206         echo "Linking $EXE failed"
207         cat $EXE.out
208         exit 1
209     }
210     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
211     echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
212 fi
213
214 if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
215     echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
216     gcc -DNAME_MAIN_CNAME -E -include include/autoconf.h include/applets.h \
217     | grep -v "^#" \
218     | grep -v "^$" \
219     > applet_lst.tmp
220     while read name main junk; do
221
222         echo "\
223 void lbb_prepare(const char *applet, char **argv);
224 int $main(int argc, char **argv);
225
226 int main(int argc, char **argv)
227 {
228         lbb_prepare(\"$name\", argv);
229         return $main(argc, argv);
230 }
231 " >"$sharedlib_dir/applet.c"
232
233         EXE="$sharedlib_dir/$name"
234         try $CC $LDFLAGS "$sharedlib_dir/applet.c" \
235                 -o $EXE \
236                 -Wl,--sort-common \
237                 -Wl,--sort-section -Wl,alignment \
238                 -Wl,--gc-sections \
239                 -L"$sharedlib_dir" -lbusybox \
240                 -Wl,--warn-common \
241         || {
242             echo "Linking $EXE failed"
243             cat $EXE.out
244             exit 1
245         }
246         rm -- "$sharedlib_dir/applet.c" $EXE.out
247         $STRIP -s --remove-section=.note --remove-section=.comment $EXE
248
249     done <applet_lst.tmp
250 fi
251
252 # libbusybox.so is needed only for -lbusybox at link time,
253 # it is not needed at runtime. Deleting to reduce confusion.
254 rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
255 exit 0 # or else we may confuse make